﻿/**********************************************************************************
 * Project Name :   
 * Remarks      :  
 * Class Name   :  AssertXml 
 * Version      :  v1.0.0.0 
 * Author       :  Joey Liang 
 * Description  : 
 * Created Time :  2013/10/16 21:53:50
 * Update Man   :  Joey Liang
 * Update Time  :  2013/10/16 21:53:50
************************************************************************/

using IdleTest.MSTest;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace IdleTest.Xml
{
    public class AssertXml : AssertInstance
    {
        public override void AssertEqual<T>(T expected, T actual, bool areEqual = true)
        {
            if (typeof(T) == typeof(XmlNode))
            {
                XmlNode expectedNode = expected as XmlNode;
                XmlNode actualNode = actual as XmlNode;

                if (!areEqual)
                {
                    areNotEqual(expectedNode, actualNode);
                }
                else if (expected == null && actual == null)
                {
                    return;
                }
                else if (expected == null || actual == null)
                {
                    base.AssertFail("由于要断言相等的两个实体之中只有一个为null，故断言相等失败！");
                }

                base.AssertEqual(expectedNode.Name, actualNode.Name, areEqual);
                base.AssertEqual(expectedNode.Value, actualNode.Value, areEqual);
                base.AssertEqual(expectedNode.OuterXml, actualNode.OuterXml, areEqual);
                base.AssertEqual<XmlNode>(expectedNode, actualNode, areEqual);

            }
            else
            {
                base.AssertEqual<T>(expected, actual, areEqual);
            }
        }

        private void areNotEqual(XmlNode expected, XmlNode actual)
        {
            if (expected == null && actual == null)
            {
                base.AssertFail("要断言不相等的两个对象均为为null，故断言相等失败！");
                return;
            }
            else if (expected == null || actual == null)
            {
                return;
            }
        }

        public override void AssertEmpty<T>(T expected, bool isEmpty = true)
        {
            base.AssertEmpty(expected, isEmpty);
            if (expected != null && expected is XmlNode)
            {
                base.AssertEmpty((expected as XmlNode).OuterXml, isEmpty);
            }
        }
    }
}
