﻿/**********************************************************************************
 * Project Name   :   
 * Remarks        :  
 * Interface Name :  IMenuUI   
 * Version        :  v1.0.0.0 
 * Author         :  Joey Liang 
 * Description    : 
 * Created Time   :  2013/8/14 22:23:41
 * Update Man     :  Joey Liang
 * Update Time    :  2013/8/14 22:23:41
************************************************************************/

using JoeyLibs.IdleStartMenu.IViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace JoeyLibs.IdleStartMenu.IUI
{
    /// <summary>
    /// 此接口起到规范用户界面类，无实际作用
    /// </summary>
        /// <typeparam name="T">控件类型</typeparam>
    public interface IMenuUI
    {
        /// <summary>
        /// 菜单ViewModel
        /// </summary>
        IMainViewModel ViewModel { get; }

        /// <summary>
        /// 创建进程启动控件集合
        /// </summary>
        void CreateProcessControls();

        /// <summary>
        /// 设置是否可以打开多个进程（需要系统支持）
        /// </summary>
        void SetMultiProcessOpened();

        /// <summary>
        /// 创建广告控件集合
        /// </summary>
        void CreateAdvert();
    }
}
