﻿/**********************************************************************************
 * Project Name :   
 * Remarks      :  
 * Class Name   :     
 * Version      :  v1.0.0.0 
 * Author       :  Joey Liang 
 * Description  : 
 * Created Time :  2013/5/22 0:24:49
 * Update Man   :  Joey Liang
 * Update Time  :  2013/5/22 0:24:49
************************************************************************/

using System;
using System.Data;

namespace JoeyLibs.Utility
{
    #region SQLExport
    /// <summary>
    /// 创建导出SQL语句的委托
    /// </summary>
    public delegate void SQLExportEventHandle(object sender, SQLExportEventArgs e);

    /// <summary>
    /// 导出SQL语句事件参数类
    /// </summary>
    public class SQLExportEventArgs : EventArgs
    {
        /// <summary>
        /// 每一条记录的导出SQL语句
        /// </summary>
        public string SQLString { get; set; }
        /// <summary>
        /// 遍历到所有数据的每一行
        /// </summary>
        public DataRow RowItem { get; set; }

        /// <summary>
        /// 实例化导出SQL语句事件参数类对象
        /// </summary>
        /// <param name="sqlString">每一条记录的导出SQL语句</param>
        /// <param name="rowItem">遍历到所有数据的每一行</param>
        public SQLExportEventArgs(string sqlString, DataRow rowItem)
        {
            this.SQLString = sqlString;
            this.RowItem = rowItem;
        }
    }
    #endregion
}
